# Analogic/Digital converter

Shows how to use the [nanoFramework.GiantGecko.Adc](http://docs.nanoframework.net/api/nanoFramework.GiantGecko.Adc.html) API to interact with the Giant Gecko ADC.

## Hardware requirements

A Giant Gecko device running a .NET nanoFramework image.

## Samples

- [Read ADC channel](Read.Channel/)
- [Continuous Scanning ADC](ContinuousSampling/)

## Related topics

### Reference

- [nanoFramework.GiantGecko.Adc](http://docs.nanoframework.net/api/nanoFramework.GiantGecko.Adc.html)

## Build the sample

1. Start Microsoft Visual Studio 2022 (VS 2019 should be OK too) and select `File > Open > Project/Solution`.
1. Starting in the folder where you unzipped the samples/cloned the repository, go to the subfolder for this specific sample. Double-click the Visual Studio Solution (.sln) file.
1. Press `Ctrl+Shift+B`, or select `Build > Build Solution`.

## Run the sample

The next steps depend on whether you just want to deploy the sample or you want to both deploy and run it.

### Deploying the sample

- Select `Build > Deploy Solution`.

### Deploying and running the sample

- To debug the sample and then run it, press F5 or select `Debug > Start Debugging`.

> **Important**: Before deploying or running the sample, please make sure your device is visible in the Device Explorer.
> **Tip**: To display the Device Explorer, go to Visual Studio menus: `View > Other Windows > Device Explorer`.
