# Threading sample pack

Demonstration on how to use [System.Threading](http://docs.nanoframework.net/api/System.Threading.html) API and related classes in order to start threads, control execution, accessing shared resources and using synchronization primitives.

## Samples

- [Basic threading](./01-Basic%20Threading/)
- [Passing parameters](./02-Passing%20Parameters/)
- [Retrieving data from threads](./03-Retrieving%20data%20from%20threads/)
- [Controlling threads](./04-Controlling%20threads/)
- [ManualResetEvent](05-ManualResetEvent/)
- [AutoResetEvent](06-AutoResetEvent/)
- [Accessing shared resources](07-Sharing%20resources/)

## Build the sample

1. Start Microsoft Visual Studio 2019 (VS 2017 should be OK too) and select `File > Open > Project/Solution`.
1. Starting in the folder where you unzipped the samples/cloned the repository, go to the subfolder for this specific sample. Double-click the Visual Studio Solution (.sln) file.
1. Press `Ctrl+Shift+B`, or select `Build > Build Solution`.

## Run the sample

The next steps depend on whether you just want to deploy the sample or you want to both deploy and run it.

### Deploying the sample

- Select `Build > Deploy Solution`.

### Deploying and running the sample

- To debug the sample and then run it, press F5 or select `Debug > Start Debugging`.

> **Important**: Before deploying or running the sample, please make sure your device is visible in the Device Explorer.

> **Tip**: To display the Device Explorer, go to Visual Studio menus: `View > Other Windows > Device Explorer`.
